diff --git a/web/config.py b/web/config.py
index 6091924b3..50b09a40c 100644
--- a/web/config.py
+++ b/web/config.py
@@ -822,6 +822,7 @@ except ImportError:
 system_config_dir = '/etc/pgadmin'
 if sys.platform.startswith('win32'):
     system_config_dir = os.environ['CommonProgramFiles'] + '/pgadmin'
+    print(system_config_dir)
 elif sys.platform.startswith('darwin'):
     system_config_dir = '/Library/Preferences/pgadmin'
 
diff --git a/web/pgadmin/browser/static/js/node.js b/web/pgadmin/browser/static/js/node.js
index 2d12c4ed9..199ee986f 100644
--- a/web/pgadmin/browser/static/js/node.js
+++ b/web/pgadmin/browser/static/js/node.js
@@ -551,7 +551,25 @@ define('pgadmin.browser.node', [
 
       }
     },
+    registerDockerPanel: function(docker, name, params) {
+      var w = docker || pgBrowser.docker,
+        p = w.findPanels(name);
+
+      if (p && p.length == 1)
+        return;
 
+      p = new pgBrowser.Panel({
+        name: name,
+        showTitle: true,
+        isCloseable: true,
+        isPrivate: true,
+        isLayoutMember: false,
+        canMaximise: true,
+        content: '<div class="obj_properties container-fluid h-100"></div>',
+        ...params,
+      });
+      p.load(w);
+    },
     registerUtilityPanel: function(docker) {
       var w = docker || pgBrowser.docker,
         p = w.findPanels('utility_props');
diff --git a/web/pgadmin/misc/bgprocess/static/js/bgprocess.js b/web/pgadmin/misc/bgprocess/static/js/bgprocess.js
index b007fec3f..ddc965e7a 100644
--- a/web/pgadmin/misc/bgprocess/static/js/bgprocess.js
+++ b/web/pgadmin/misc/bgprocess/static/js/bgprocess.js
@@ -9,7 +9,7 @@
 
 define('misc.bgprocess', [
   'sources/pgadmin', 'sources/gettext', 'sources/url_for', 'underscore',
-  'jquery', 'pgadmin.browser', 'alertify',
+  'jquery', 'pgadmin.browser', 'alertify', 'pgadmin.tools.file_manager',
 ], function(
   pgAdmin, gettext, url_for, _, $, pgBrowser, Alertify
 ) {
@@ -625,9 +625,7 @@ define('misc.bgprocess', [
 
         var self = this;
         if(self.current_storage_dir) {
-          pgBrowser.Events.trigger(
-            'pgadmin:tools:storage_manager', self.current_storage_dir
-          );
+          pgAdmin.Tools.FileManager.openStorageManager(self.current_storage_dir);
         }
       },
     });
diff --git a/web/pgadmin/misc/file_manager/__init__.py b/web/pgadmin/misc/file_manager/__init__.py
index f9562b1a8..abedf800c 100644
--- a/web/pgadmin/misc/file_manager/__init__.py
+++ b/web/pgadmin/misc/file_manager/__init__.py
@@ -28,9 +28,11 @@ from flask_babel import gettext
 from flask_security import login_required
 from pgadmin.utils import PgAdminModule
 from pgadmin.utils import get_storage_directory
-from pgadmin.utils.ajax import make_json_response
+from pgadmin.utils.ajax import make_json_response, unauthorized, \
+    internal_server_error
 from pgadmin.utils.preferences import Preferences
 from pgadmin.utils.constants import PREF_LABEL_OPTIONS, MIMETYPE_APP_JS
+from pgadmin.settings.utils import get_file_type_setting
 
 # Checks if platform is Windows
 if _platform == "win32":
@@ -132,9 +134,9 @@ class FileManagerModule(PgAdminModule):
             list: a list of url endpoints exposed to the client.
         """
         return [
+            'file_manager.init',
             'file_manager.filemanager',
             'file_manager.index',
-            'file_manager.get_trans_id',
             'file_manager.delete_trans_id',
             'file_manager.save_last_dir',
             'file_manager.save_file_dialog_view',
@@ -196,74 +198,56 @@ def utility():
         mimetype=MIMETYPE_APP_JS)
 
 
-@blueprint.route("/file_manager.js")
-@login_required
-def file_manager_js():
-    """render the required javascript"""
-    return Response(response=render_template(
-        "file_manager/js/file_manager.js", _=gettext),
-        status=200,
-        mimetype=MIMETYPE_APP_JS)
-
-
-@blueprint.route("/en.json")
-@login_required
-def language():
-    """render the required javascript"""
-    return Response(response=render_template(
-        "file_manager/js/languages/en.json", _=gettext),
-        status=200)
-
-
-@blueprint.route("/file_manager_config.js")
-@login_required
-def file_manager_config_js():
-    """render the required javascript"""
-    return Response(response=render_template(
-        "file_manager/js/file_manager_config.js", _=gettext),
-        status=200,
-        mimetype=MIMETYPE_APP_JS)
-
-
-@blueprint.route("/<int:trans_id>/file_manager_config.json")
-@login_required
-def file_manager_config(trans_id):
-    """render the required json"""
-    data = Filemanager.get_trasaction_selection(trans_id)
-    pref = Preferences.module('file_manager')
-    file_dialog_view = pref.preference('file_dialog_view').get()[0]
-    show_hidden_files = pref.preference('show_hidden_files').get()
-
-    return Response(response=render_template(
-        "file_manager/js/file_manager_config.json",
-        _=gettext,
-        data=data,
-        file_dialog_view=file_dialog_view,
-        show_hidden_files=show_hidden_files
-    ),
-        status=200,
-        mimetype="application/json"
-    )
-
-
 @blueprint.route(
-    "/get_trans_id", methods=["GET", "POST"], endpoint='get_trans_id'
+    "/init", methods=["POST"], endpoint='init'
 )
 @login_required
-def get_trans_id():
+def init_filemanager():
     if len(req.data) != 0:
         configs = json.loads(req.data)
         trans_id = Filemanager.create_new_transaction(configs)
-        global transid
-        transid = trans_id
-    return make_json_response(
-        data={'fileTransId': transid, 'status': True}
-    )
+        data = Filemanager.get_trasaction_selection(trans_id)
+        pref = Preferences.module('file_manager')
+
+        res_data = {
+            'transId': trans_id,
+            "options": {
+                "culture": "en",
+                "lang": "py",
+                "defaultViewMode":
+                    pref.preference('file_dialog_view').get()[0],
+                "autoload": True,
+                "showFullPath": False,
+                "dialog_type": data['dialog_type'],
+                "show_hidden_files":
+                    pref.preference('show_hidden_files').get(),
+                "fileRoot": data['fileroot'],
+                "capabilities": data['capabilities'],
+                "allowed_file_types": data['supported_types'],
+                "platform_type": data['platform_type'],
+                "show_volumes": data['show_volumes'],
+                "homedir": data['homedir'],
+                "last_selected_format": get_file_type_setting(
+                    data['supported_types'])
+            },
+            "security": {
+                "uploadPolicy": data['security']['uploadPolicy'],
+                "uploadRestrictions": data['security']['uploadRestrictions'],
+            },
+            "upload": {
+                "multiple": data['upload']['multiple'],
+                "number": 20,
+                "fileSizeLimit": data['upload']['fileSizeLimit'],
+                "imagesOnly": False
+            }
+        }
+
+    return make_json_response(data=res_data)
 
 
 @blueprint.route(
-    "/del_trans_id/<int:trans_id>",
-    methods=["GET", "POST"], endpoint='delete_trans_id'
+    "/delete_trans_id/<int:trans_id>",
+    methods=["DELETE"], endpoint='delete_trans_id'
 )
 @login_required
 def delete_trans_id(trans_id):
@@ -279,9 +263,7 @@ def delete_trans_id(trans_id):
 @login_required
 def save_last_directory_visited(trans_id):
     blueprint.last_directory_visited.set(req.json['path'])
-    return make_json_response(
-        data={'status': True}
-    )
+    return make_json_response(status=200)
 
 
 @blueprint.route(
@@ -291,9 +273,7 @@ def save_last_directory_visited(trans_id):
 @login_required
 def save_file_dialog_view(trans_id):
     blueprint.file_dialog_view.set(req.json['view'])
-    return make_json_response(
-        data={'status': True}
-    )
+    return make_json_response(status=200)
 
 
 @blueprint.route(
@@ -303,9 +283,7 @@ def save_file_dialog_view(trans_id):
 @login_required
 def save_show_hidden_file_option(trans_id):
     blueprint.show_hidden_files.set(req.json['show_hidden'])
-    return make_json_response(
-        data={'status': True}
-    )
+    return make_json_response(status=200)
 
 
 class Filemanager(object):
@@ -321,14 +299,6 @@ class Filemanager(object):
 
     def __init__(self, trans_id):
         self.trans_id = trans_id
-        self.patherror = encode_json(
-            {
-                'Error': gettext(
-                    'No permission to operate on specified path.'
-                ),
-                'Code': 0
-            }
-        )
         self.dir = get_storage_directory()
 
         if self.dir is not None and isinstance(self.dir, list):
@@ -387,7 +357,7 @@ class Filemanager(object):
         # tuples with (capabilities, files_only, folders_only, title)
         capability_map = {
             'select_file': (
-                ['select_file', 'rename', 'upload', 'create'],
+                ['select_file', 'rename', 'upload', 'delete'],
                 True,
                 False,
                 gettext("Select File")
@@ -421,6 +391,8 @@ class Filemanager(object):
 
         # get last visited directory, if not present then traverse in reverse
         # order to find closest parent directory
+        if 'init_path' in params:
+            blueprint.last_directory_visited.get(params['init_path'])
         last_dir = blueprint.last_directory_visited.get()
         check_dir_exists = False
         if last_dir is None:
@@ -436,9 +408,8 @@ class Filemanager(object):
 
         # create configs using above configs
         configs = {
-            # for JS json compatibility
-            "fileroot": last_dir.replace('\\', '\\\\'),
-            "homedir": homedir.replace('\\', '\\\\'),
+            "fileroot": last_dir,
+            "homedir": homedir,
             "dialog_type": fm_type,
             "title": title,
             "upload": {
@@ -499,14 +470,14 @@ class Filemanager(object):
         file_manager_data = session['fileManagerData']
         # Return from the function if transaction id not found
         if str(trans_id) not in file_manager_data:
-            return make_json_response(data={'status': True})
+            return make_json_response(status=200)
 
         # Remove the information of unique transaction id
         # from the session variable.
         file_manager_data.pop(str(trans_id), None)
         session['fileManagerData'] = file_manager_data
 
-        return make_json_response(data={'status': True})
+        return make_json_response(status=200)
 
     @staticmethod
     def _get_drives_with_size(drive_name=None):
@@ -590,7 +561,7 @@ class Filemanager(object):
         :param orig_path: path after user dir
         :return:
         """
-        files = {}
+        files = []
 
         for f in sorted(os.listdir(orig_path)):
             system_path = os.path.join(os.path.join(orig_path, f))
@@ -617,14 +588,13 @@ class Filemanager(object):
                 if files_only == 'true':
                     continue
                 file_extension = "dir"
-                user_path = "{0}/".format(user_path)
             # filter files based on file_type
             elif Filemanager._skip_file_extension(
                     file_type, supported_types, folders_only, file_extension):
                 continue
 
             # create a list of files and folders
-            files[f] = {
+            files.append({
                 "Filename": f,
                 "Path": user_path,
                 "file_type": file_extension,
@@ -634,7 +604,7 @@ class Filemanager(object):
                     "Date Modified": modified,
                     "Size": sizeof_fmt(getsize(system_path))
                 }
-            }
+            })
 
         return files
 
@@ -649,23 +619,16 @@ class Filemanager(object):
 
         path = unquote(path)
 
-        try:
-            Filemanager.check_access_permission(in_dir, path)
-        except Exception as e:
-            Filemanager.resume_windows_warning()
-            files = {
-                'Code': 0,
-                'Error': str(e)
-            }
-            return files
+        Filemanager.check_access_permission(in_dir, path)
+        Filemanager.resume_windows_warning()
 
-        files = {}
+        files = []
         if (_platform == "win32" and (path == '/' or path == '\\'))\
                 and in_dir is None:
             drives = Filemanager._get_drives_with_size()
             for drive, drive_size in drives:
                 path = file_name = "{0}:".format(drive)
-                files[file_name] = {
+                files.append({
                     "Filename": file_name,
                     "Path": path,
                     "file_type": 'drive',
@@ -675,7 +638,7 @@ class Filemanager(object):
                         "Date Modified": "",
                         "Size": drive_size
                     }
-                }
+                })
             Filemanager.resume_windows_warning()
             return files
 
@@ -683,10 +646,9 @@ class Filemanager(object):
 
         if not path_exists(orig_path):
             Filemanager.resume_windows_warning()
-            return {
-                'Code': 0,
-                'Error': gettext("'{0}' file does not exist.").format(path)
-            }
+            return make_json_response(
+                status=404,
+                errormsg=gettext("'{0}' file does not exist.").format(path))
 
         user_dir = path
         folders_only = trans_data.get('folders_only', '')
@@ -705,11 +667,7 @@ class Filemanager(object):
             if (hasattr(e, 'strerror') and
                     e.strerror == gettext('Permission denied')):
                 err_msg = str(e.strerror)
-
-            files = {
-                'Code': 0,
-                'Error': err_msg
-            }
+            return unauthorized(err_msg)
         Filemanager.resume_windows_warning()
         return files
 
@@ -735,9 +693,10 @@ class Filemanager(object):
 
         # Do not allow user to access outside his storage dir
         # in server mode.
-        if not orig_path.startswith(in_dir):
-            raise InternalServerError(
-                gettext("Access denied ({0})").format(path))
+        try:
+            pathlib.Path(orig_path).relative_to(in_dir)
+        except ValueError:
+            raise PermissionError(gettext("Access denied ({0})").format(path))
 
     @staticmethod
     def get_abs_path(in_dir, path):
@@ -789,33 +748,13 @@ class Filemanager(object):
             self.dir = ""
         orig_path = "{0}{1}".format(self.dir, path)
 
-        try:
-            Filemanager.check_access_permission(self.dir, path)
-        except Exception as e:
-            thefile = {
-                'Filename': split_path(path)[-1],
-                'FileType': '',
-                'Path': path,
-                'Error': str(e),
-                'Code': 0,
-                'Info': '',
-                'Properties': {
-                    date_created: '',
-                    date_modified: '',
-                    'Width': '',
-                    'Height': '',
-                    'Size': ''
-                }
-            }
-            return thefile
+        Filemanager.check_access_permission(self.dir, path)
 
         user_dir = path
         thefile = {
             'Filename': split_path(orig_path)[-1],
             'FileType': '',
             'Path': user_dir,
-            'Error': '',
-            'Code': 1,
             'Info': '',
             'Properties': {
                 date_created: '',
@@ -827,10 +766,9 @@ class Filemanager(object):
         }
 
         if not path_exists(orig_path):
-            thefile['Error'] = gettext(
-                "'{0}' file does not exist.").format(path)
-            thefile['Code'] = -1
-            return thefile
+            return make_json_response(
+                status=404,
+                errormsg=gettext("'{0}' file does not exist.").format(path))
 
         if split_path(user_dir)[-1] == '/'\
                 or os.path.isfile(orig_path) is False:
@@ -868,19 +806,12 @@ class Filemanager(object):
         Rename file or folder
         """
         if not self.validate_request('rename'):
-            return self.ERROR_NOT_ALLOWED
+            return unauthorized(self.ERROR_NOT_ALLOWED['Error'])
 
         the_dir = self.dir if self.dir is not None else ''
 
-        try:
-            Filemanager.check_access_permission(the_dir, old)
-            Filemanager.check_access_permission(the_dir, new)
-        except Exception as e:
-            res = {
-                'Error': str(e),
-                'Code': 0
-            }
-            return res
+        Filemanager.check_access_permission(the_dir, old)
+        Filemanager.check_access_permission(the_dir, new)
 
         # check if it's dir
         if old[-1] == '/':
@@ -906,39 +837,27 @@ class Filemanager(object):
         try:
             os.rename(oldpath_sys, newpath_sys)
         except Exception as e:
-            code = 0
-            error_msg = "{0} {1}".format(
-                gettext('There was an error renaming the file:'), e)
+            return internal_server_error("{0} {1}".format(
+                gettext('There was an error renaming the file:'), e))
 
-        result = {
+        return {
             'Old Path': old,
             'Old Name': oldname,
             'New Path': newpath,
             'New Name': newname,
-            'Error': error_msg,
-            'Code': code
         }
 
-        return result
-
     def delete(self, path=None, req=None):
         """
         Delete file or folder
         """
         if not self.validate_request('delete'):
-            return self.ERROR_NOT_ALLOWED
+            return unauthorized(self.ERROR_NOT_ALLOWED['Error'])
 
         the_dir = self.dir if self.dir is not None else ''
         orig_path = "{0}{1}".format(the_dir, path)
 
-        try:
-            Filemanager.check_access_permission(the_dir, path)
-        except Exception as e:
-            res = {
-                'Error': str(e),
-                'Code': 0
-            }
-            return res
+        Filemanager.check_access_permission(the_dir, path)
 
         err_msg = ''
         code = 1
@@ -948,23 +867,17 @@ class Filemanager(object):
             else:
                 os.remove(orig_path)
         except Exception as e:
-            code = 0
-            err_msg = str(e.strerror)
+            return internal_server_error("{0} {1}".format(
+                gettext('There was an error deleting the file:'), e))
 
-        result = {
-            'Path': path,
-            'Error': err_msg,
-            'Code': code
-        }
-
-        return result
+        return make_json_response(status=200)
 
     def add(self, req=None):
         """
         File upload functionality
         """
         if not self.validate_request('upload'):
-            return self.ERROR_NOT_ALLOWED
+            return unauthorized(self.ERROR_NOT_ALLOWED['Error'])
 
         the_dir = self.dir if self.dir is not None else ''
         err_msg = ''
@@ -986,7 +899,7 @@ class Filemanager(object):
                         )
                     ).relative_to(the_dir)
             except ValueError:
-                return self.ERROR_NOT_ALLOWED
+                return unauthorized(self.ERROR_NOT_ALLOWED['Error'])
 
             with open(new_name, 'wb') as f:
                 while True:
@@ -996,25 +909,15 @@ class Filemanager(object):
                         break
                     f.write(data)
         except Exception as e:
-            code = 0
-            err_msg = str(e.strerror) if hasattr(e, 'strerror') else str(e)
+            return internal_server_error("{0} {1}".format(
+                gettext('There was an error adding the file:'), e))
 
-        try:
-            Filemanager.check_access_permission(the_dir, path)
-        except Exception as e:
-            res = {
-                'Error': str(e),
-                'Code': 0
-            }
-            return res
+        Filemanager.check_access_permission(the_dir, path)
 
-        result = {
+        return {
             'Path': path,
             'Name': new_name,
-            'Error': err_msg,
-            'Code': code
         }
-        return result
 
     def is_file_exist(self, path, name, req=None):
         """
@@ -1026,48 +929,40 @@ class Filemanager(object):
 
         name = unquote(name)
         path = unquote(path)
-        try:
-            orig_path = "{0}{1}".format(the_dir, path)
-            Filemanager.check_access_permission(
-                the_dir, "{}{}".format(path, name))
 
-            new_name = "{0}{1}".format(orig_path, name)
-            if not os.path.exists(new_name):
-                code = 0
-        except Exception as e:
+        orig_path = "{0}{1}".format(the_dir, path)
+        Filemanager.check_access_permission(
+            the_dir, "{}{}".format(path, name))
+
+        new_name = "{0}{1}".format(orig_path, name)
+        if not os.path.exists(new_name):
             code = 0
-            if hasattr(e, 'strerror'):
-                err_msg = str(e.strerror)
-            else:
-                err_msg = str(e)
 
-        result = {
+        return {
             'Path': path,
             'Name': name,
-            'Error': err_msg,
-            'Code': code
+            'Code': code,
         }
 
-        return result
-
     @staticmethod
-    def get_new_name(in_dir, path, new_name, count=1):
+    def get_new_name(in_dir, path, name):
         """
         Utility to provide new name for folder if file
         with same name already exists
         """
-        last_char = new_name[-1]
-        t_new_path = "{}/{}{}_{}".format(in_dir, path, new_name, count)
-        if last_char == 'r' and not path_exists(t_new_path):
-            return t_new_path, new_name
-        else:
-            last_char = int(t_new_path[-1]) + 1
-            new_path = "{}/{}{}_{}".format(in_dir, path, new_name, last_char)
-            if path_exists(new_path):
-                count += 1
-                return Filemanager.get_new_name(in_dir, path, new_name, count)
+        new_name = name
+        count = 0
+        while True:
+            file_path = "{}{}/".format(path, new_name)
+            create_path = file_path
+            if in_dir != "":
+                create_path = "{}/{}".format(in_dir, file_path)
+
+            if not path_exists(create_path):
+                return create_path, file_path, new_name
             else:
-                return new_path, new_name
+                count += 1
+                new_name = "{}_{}".format(name, count)
 
     @staticmethod
     def check_file_for_bom_and_binary(filename, enc="utf-8"):
@@ -1125,17 +1020,15 @@ class Filemanager(object):
                 append({os.path.basename(filename): enc})
 
         except IOError as ex:
-            status = False
             # we don't want to expose real path of file
             # so only show error message.
             if ex.strerror == 'Permission denied':
-                err_msg = str(ex.strerror)
+                return unauthorized(str(ex.strerror))
             else:
-                err_msg = str(ex)
+                return internal_server_error(str(ex))
 
         except Exception as ex:
-            status = False
-            err_msg = str(ex)
+            return internal_server_error(str(ex))
 
         # Remove root storage path from error message
         # when running in Server mode
@@ -1146,52 +1039,30 @@ class Filemanager(object):
 
         return status, err_msg, is_binary, is_startswith_bom, enc
 
-    def addfolder(self, path, name):
+    def addfolder(self, path, name, req=None):
         """
         Functionality to create new folder
         """
         if not self.validate_request('create'):
-            return self.ERROR_NOT_ALLOWED
+            return unauthorized(self.ERROR_NOT_ALLOWED['Error'])
 
-        the_dir = self.dir if self.dir is not None else ''
+        user_dir = self.dir if self.dir is not None else ''
+
+        Filemanager.check_access_permission(user_dir, "{}{}".format(
+            path, name))
 
+        create_path, new_path, new_name = \
+            self.get_new_name(user_dir, path, name)
         try:
-            Filemanager.check_access_permission(the_dir, "{}{}".format(
-                path, name))
+            os.mkdir(create_path)
         except Exception as e:
-            res = {
-                'Error': str(e),
-                'Code': 0
-            }
-            return res
-
-        if the_dir != "":
-            new_path = "{}/{}{}/".format(the_dir, path, name)
-        else:
-            new_path = "{}{}/".format(path, name)
-
-        err_msg = ''
-        code = 1
-        new_name = name
-        if not path_exists(new_path):
-            try:
-                os.mkdir(new_path)
-            except Exception as e:
-                code = 0
-                err_msg = str(e.strerror)
-        else:
-            new_path, new_name = self.get_new_name(the_dir, path, name)
-            try:
-                os.mkdir(new_path)
-            except Exception as e:
-                code = 0
-                err_msg = str(e.strerror)
+            return internal_server_error(str(e))
 
         result = {
             'Parent': path,
+            'Path': new_path,
             'Name': new_name,
-            'Error': err_msg,
-            'Code': code
+            'Date Modified': time.ctime(time.time())
         }
 
         return result
@@ -1201,20 +1072,14 @@ class Filemanager(object):
         Functionality to download file
         """
         if not self.validate_request('download'):
-            return self.ERROR_NOT_ALLOWED
+            return unauthorized(self.ERROR_NOT_ALLOWED['Error'])
 
         the_dir = self.dir if self.dir is not None else ''
         orig_path = "{0}{1}".format(the_dir, path)
 
-        try:
-            Filemanager.check_access_permission(
-                the_dir, "{}{}".format(path, path)
-            )
-        except Exception as e:
-            resp = Response(str(e))
-            resp.headers['Content-Disposition'] = \
-                'attachment; filename=' + name
-            return resp
+        Filemanager.check_access_permission(
+            the_dir, "{}{}".format(path, path)
+        )
 
         name = os.path.basename(path)
         if orig_path and len(orig_path) > 0:
@@ -1232,12 +1097,7 @@ class Filemanager(object):
     def permission(self, path=None, req=None):
         the_dir = self.dir if self.dir is not None else ''
         res = {'Code': 1}
-        try:
-            Filemanager.check_access_permission(the_dir, path)
-        except Exception as e:
-            err_msg = str(e)
-            res['Code'] = 0
-            res['Error'] = err_msg
+        Filemanager.check_access_permission(the_dir, path)
         return res
 
 
@@ -1272,9 +1132,12 @@ def file_manager(trans_id):
         }
         mode = req.args['mode']
 
+    func = getattr(my_fm, mode)
     try:
-        func = getattr(my_fm, mode)
         res = func(**kwargs)
-        return make_json_response(data={'result': res, 'status': True})
-    except Exception:
-        return getattr(my_fm, mode)(**kwargs)
+    except PermissionError as e:
+        return unauthorized(str(e))
+
+    if type(res) == Response:
+        return res
+    return make_json_response(data={'result': res, 'status': True})
diff --git a/web/pgadmin/misc/file_manager/static/js/FileManagerModule.jsx b/web/pgadmin/misc/file_manager/static/js/FileManagerModule.jsx
new file mode 100644
index 000000000..2c8bd8aa6
--- /dev/null
+++ b/web/pgadmin/misc/file_manager/static/js/FileManagerModule.jsx
@@ -0,0 +1,121 @@
+
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import gettext from 'sources/gettext';
+import Notifier from '../../../../static/js/helpers/Notifier';
+import React from 'react';
+import FileManager from './components/FileManager';
+import { getBrowser } from '../../../../static/js/utils';
+
+export default class FileManagerModule {
+  static instance;
+
+  static getInstance(...args) {
+    if(!FileManagerModule.instance) {
+      FileManagerModule.instance = new FileManagerModule(...args);
+    }
+    return FileManagerModule.instance;
+  }
+
+  constructor(pgAdmin) {
+    this.pgAdmin = pgAdmin;
+  }
+
+  init() {
+    if(this.initialized)
+      return;
+    this.initialized = true;
+
+    if(this.pgAdmin.server_mode == 'True') {
+      // Define the nodes on which the menus to be appear
+      this.pgAdmin.Browser.add_menus([{
+        name: 'storage_manager',
+        module: this,
+        applies: ['tools'],
+        callback: 'openStorageManager',
+        priority: 11,
+        label: gettext('Storage Manager...'),
+        enable: true,
+      }]);
+    }
+  }
+
+  openStorageManager(path) {
+    this.show({
+      dialog_type: 'storage_dialog',
+      supported_types: ['sql', 'csv', 'json', '*'],
+      dialog_title: gettext('Storage Manager'),
+      path: path,
+    });
+  }
+
+  showInternal(params, onOK, onCancel, modalObj) {
+    const modal = modalObj || Notifier;
+    let title = params.dialog_title;
+    if(!title) {
+      if(params.dialog_type == 'create_file') {
+        title = gettext('Save File');
+      } else if(params.dialog_type == 'select_file') {
+        title = gettext('Select File');
+      } else {
+        title = gettext('Storage Manager');
+      }
+    }
+    modal.showModal(title, (closeModal)=>{
+      return (
+        <FileManager
+          params={params}
+          closeModal={closeModal}
+          onCancel={onCancel}
+          onOK={onOK}
+        />
+      );
+    }, {
+      isResizeable: true,
+      onClose: onCancel,
+      dialogWidth: 700, dialogHeight: 400
+    });
+  }
+
+  showNative(params, onOK, onCancel) {
+    // https://docs.nwjs.io/en/latest/References/Changes%20to%20DOM/
+    let fileEle = document.createElement('input');
+    let accept = params.supported_types?.map((v)=>(v=='*' ? '' : `.${v}`))?.join(',');
+    fileEle.setAttribute('type', 'file');
+    fileEle.setAttribute('accept', accept);
+    fileEle.onchange = (e)=>{
+      if(e.target.value) {
+        onOK?.(e.target.value);
+      } else {
+        onCancel?.();
+      }
+    };
+    if(params.dialog_type == 'create_file') {
+      fileEle.setAttribute('nwsaveas', '');
+    } else if(params.dialog_type == 'select_folder') {
+      fileEle.setAttribute('nwdirectory', '');
+    }
+    fileEle.dispatchEvent(new MouseEvent('click'));
+  }
+
+  show(params, onOK, onCancel, modalObj) {
+    let {name: browser} = getBrowser();
+    if(browser == 'Nwjs') {
+      try {
+        this.showNative(params, onOK, onCancel);
+      } catch {
+        // Fall back to internal
+        this.showInternal(params, onOK, onCancel, modalObj);
+      }
+    } else {
+      // Fall back to internal
+      this.showInternal(params, onOK, onCancel, modalObj);
+    }
+  }
+}
